/**********************************************************************
 * Copyright (c) 2007 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: AbstractTreeJSON.java,v 1.1 2007/10/26 18:33:37 sleeloy Exp $
 **********************************************************************/
package org.eclipse.cosmos.provisional.dr.ps.common;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class for Servlet: ReportDeploymentJSON
 *
 */
 public abstract class AbstractJSON extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		render(request, response);
	}  	
	
	protected abstract IOutputter getOutputter(HttpServletRequest request);		
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}   

	protected IIDResolver getIDResolver(HttpServletRequest request){
		IIDResolver idResolver;
		idResolver = new SessionResolveFixedTreeIDs(request.getSession());
		idResolver.clear();
		return idResolver;
	
	}
	
	protected void render(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//let set the lookup map in session
		IOutputter outputter = getOutputter(request);
		IIDResolver idResolver = getIDResolver(request);
		outputter.setIdResolver(idResolver);
		try {
			PrintWriter fw = response.getWriter();
			
			outputter.render(fw, new RequestParametersImpl(request));
			fw.close();
		} catch (Exception e) {
			e.printStackTrace();
			throw new ServletException(e);
		}
		
	}


	
}
