/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
dojo.provide("org.eclipse.cosmos.provisional.dr.ps.components.widget.QueryDialog");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");

dojo.declare(
   "org.eclipse.cosmos.provisional.dr.ps.components.query.QueryDialog",
	// superclass	
	org.eclipse.cosmos.provisional.dr.ps.components.query.BasicQuery,
	{
		labelDialogQuery:"",
		bindInput: function(data, callbackMethod){
			var builder = new org.eclipse.cosmos.provisional.dr.ps.components.widget.QueryDialog({callback: callbackMethod, labelQuery:this.labelDialogQuery});
			builder.show();		
		},
		render: function(input){
			return input;
		}
	}
); 

 dojo.declare(
	"org.eclipse.cosmos.provisional.dr.ps.components.widget.QueryDialog",
	[dijit._Widget, dijit._Templated, dijit._Container], 
	{
	 	title:"Query Builder Dialog",
	 	rows:12,
	 	cols:80,
		labelQuery:"",	 	
		templatePath:dojo.moduleUrl("org.eclipse.cosmos.provisional.dr.ps.components.widget", "html/Dialog.html"),
		widgetsInTemplate: true,
		widgetId: "queryDialog",
		show: function(){
			this.dialogBox.show();
		},
		onCancel: function(){
			this.dialogBox.onCancel();
		},
		submitQuery: function(){
			var query = "query="+document.getElementById(this.widgetId+"_queryTextArea").value;
			
			this.callback(query);
		},
		postMixInProperties: function(){
			//call superclass
			org.eclipse.cosmos.provisional.dr.ps.components.widget.QueryDialog.superclass.postMixInProperties.apply(this, arguments);
		},
		postCreate: function(){
			//call superclass
			org.eclipse.cosmos.provisional.dr.ps.components.widget.QueryDialog.superclass.postCreate.apply(this, arguments);			
			this.dialogBox = dijit.byId("dijit_Dialog_0");
		}
		
	}
);      